/**
 * Author: Davide Ficano
 * Date  : 25-02-06
 */
var gInstallTimeOutSettings = {
    onLoad : function() {
        gInstallTimeOutSettings.prefs = new InstallTimeOutPrefs();
        gInstallTimeOutSettings.initControls();
        sizeToContent();
    },

    onAccept : function() {
        var isValid = true;
        var thiz = gInstallTimeOutSettings;
        try {
            thiz.prefs.showDialog = thiz.oInstallRadioGroup.selectedIndex != 0;
            thiz.prefs.secondsCount = thiz.oSecondsCount.value;
            thiz.prefs.savePrefs();
        } catch (err) {
            alert("gInstallTimeOutSettings.onAccept: " + err);
        }

        return isValid;
    },

    initControls : function() {
        var thiz = gInstallTimeOutSettings;

        thiz.oInstallRadioGroup = document.getElementById("installRadioGroup");
        thiz.oSecondsCount = document.getElementById("secondsCount");

        thiz.initValues();
    },

    getNavigationWindow : function() {
        var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
        var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
        var win = windowManagerInterface.getMostRecentWindow("navigator:browser");

        if (!win) {
            win = window.openDialog(
                "chrome://browser/content/browser.xul",
                "_blank",
                "chrome,all,dialog=no",
                "about:blank", null, null);
        }

        return win;
    },

    openUrl : function(aEvent) {
        var url = aEvent.currentTarget.getAttribute("url");

        try {
            // Check for Songbird, dirty code!
            var theMainPane = opener.opener.document.getElementById("frame_main_pane");
            if (theMainPane) {
                theMainPane.loadURI(url, null, null);
                return;
            }
        } catch (err) {
        }
        
        try {
            var navWin = gInstallTimeOutSettings.getNavigationWindow();
            var browser = navWin.document.getElementById("content");

            browser.selectedTab = browser.addTab(url);
        } catch (err) {
            // This isn't a browser (e.g. Thunderbird, NVU)
            try {
                InstallTimeOutCommon.loadExternalUrl(url);
            } catch (err) {
            }
        }
    },

    initValues : function() {
        var thiz = gInstallTimeOutSettings;

        thiz.oInstallRadioGroup = document.getElementById("installRadioGroup");
        thiz.oSecondsCount = document.getElementById("secondsCount");

        thiz.oInstallRadioGroup.selectedIndex = !thiz.prefs.showDialog ? 0 : 1;
        thiz.oSecondsCount.value = thiz.prefs.secondsCount;
        if (!thiz.prefs.showDialog) {
            thiz.oSecondsCount.disabled = true;
        }
    },

    doSelect : function(index) {
        var thiz = gInstallTimeOutSettings;

        thiz.oSecondsCount.disabled = index == 0;
    }
};
