// Copyright 2005 Dulance Inc.
// All Rights Reserved.

var gInstallTimeOutUninstall = {
    onload: function(evt) {
        gInstallTimeOutUninstall.init(evt);
    },
    init: function() {
        if (gExtensionsViewController && gExtensionsViewController.commands && gExtensionsViewController.commands.cmd_uninstall) {
            gExtensionsViewController.commands.cmd_uninstallOriginal = gExtensionsViewController.commands.cmd_uninstall;
            gExtensionsViewController.commands.cmd_uninstall = function (aSelectedItem) {
                if (gWindowState != "extensions") {
                    return this.cmd_uninstallOriginal(aSelectedItem);
                }
                var name = aSelectedItem.getAttribute("name");
                if (name != "InstallTimeOut") {
                    return this.cmd_uninstallOriginal(aSelectedItem);
                }
                  // Confirm the uninstall
                  var extensionsStrings = document.getElementById("extensionsStrings");
                  var brandStrings = document.getElementById("brandStrings");

                var title = extensionsStrings.getFormattedString("queryUninstallTitle", [name]);
                var message = extensionsStrings.getFormattedString("queryUninstallExtensionMessage", [name, name]);

                // XXXben - improve the wording on the buttons here!
                var promptSvc = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                              .getService(Components.interfaces.nsIPromptService);
                if (!promptSvc.confirm(window, title, message))
                    return;

                var selectedID = aSelectedItem.id;
                var selectedElement = document.getElementById(selectedID);
                var nextElement = selectedElement.nextSibling;
                if (!nextElement)
                    nextElement = selectedElement.previousSibling;
                nextElement = nextElement.id;

                try {
                    gExtensionManager.uninstallExtension(stripPrefix(selectedID, gItemType));
                } catch (e) {
                    gExtensionManager.uninstallItem(getIDFromResourceURI(selectedID));
                }

                gExtensionsView.selected = document.getElementById(nextElement);

                gInstallTimeOutUninstall.cleanUp();
            }
        }
        return true;
    },
    
    cleanUp : function() {
        var prefs = new InstallTimeOutPrefs();
        prefs.unregister();
    }
};

window.addEventListener("load", gInstallTimeOutUninstall.onload, false);
